using System;
using System.Text;

using NUnit.Framework;

namespace Smdn.Net.Imap4 {
  [TestFixture]
  public class ImapEncodingTest {
    [Test]
    public void TestEncodeTransfer7BitValidChar()
    {
      ImapEncoding.Transfer7Bit.GetBytes("0004 append \"INBOX\" (\\Seen) {33}\r\n\x00\x20\x40\x60\x7f");
    }

    [Test]
    public void TestEncodeTransfer8BitValidChar()
    {
      ImapEncoding.Transfer8Bit.GetBytes("0004 append \"INBOX\" (\\Seen) {33}\r\n\x00\x20\x40\x60\x80\xa0\xc0\xe0\xff");
    }

    [Test]
    [ExpectedException(typeof(EncoderFallbackException))]
    public void TestEncodeTransfer7BitInvalidChar()
    {
      ImapEncoding.Transfer7Bit.GetBytes("\x20\x40\x60\x80");
    }

    [Test]
    [ExpectedException(typeof(EncoderFallbackException))]
    public void TestEncodeTransfer8BitInvalidChar()
    {
      ImapEncoding.Transfer8Bit.GetBytes("INBOX.日本語");
    }
  }
}
