// 
// Author:
//       smdn <smdn@mail.invisiblefulmoon.net>
// 
// Copyright (c) 2008-2009 smdn
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;

namespace Smdn.Interop.Sspi {
  [CLSCompliant(false)]
  public enum SECURITY_STATUS : uint {
    SEC_E_OK = 0,
    SEC_E_INSUFFICIENT_MEMORY         = 0x80090300,
    SEC_E_INVALID_HANDLE              = 0x80090301,
    SEC_E_UNSUPPORTED_FUNCTION        = 0x80090302,
    SEC_E_TARGET_UNKNOWN              = 0x80090303,
    SEC_E_INTERNAL_ERROR              = 0x80090304,
    SEC_E_SECPKG_NOT_FOUND            = 0x80090305,
    SEC_E_NOT_OWNER                   = 0x80090306,
    SEC_E_CANNOT_INSTALL              = 0x80090307,
    SEC_E_INVALID_TOKEN               = 0x80090308,
    SEC_E_CANNOT_PACK                 = 0x80090309,
    SEC_E_QOP_NOT_SUPPORTED           = 0x8009030a,
    SEC_E_NO_IMPERSONATION            = 0x8009030b,
    SEC_E_LOGON_DENIED                = 0x8009030c,
    SEC_E_UNKNOWN_CREDENTIALS         = 0x8009030d,
    SEC_E_NO_CREDENTIALS              = 0x8009030e,
    SEC_E_MESSAGE_ALTERED             = 0x8009030f,
    SEC_E_OUT_OF_SEQUENCE             = 0x80090310,
    SEC_E_NO_AUTHENTICATING_AUTHORITY = 0x80090311,
    SEC_I_CONTINUE_NEEDED             = 0x00090312,
    SEC_I_COMPLETE_NEEDED             = 0x00090313,
    SEC_I_COMPLETE_AND_CONTINUE       = 0x00090314,
    SEC_I_LOCAL_LOGON                 = 0x00090315,
    SEC_E_BAD_PKGID                   = 0x80090316,
    SEC_E_CONTEXT_EXPIRED             = 0x80090317,
    SEC_E_INCOMPLETE_MESSAGE          = 0x80090318,
    SEC_E_INCOMPLETE_CREDENTIALS      = 0x80090320,
    SEC_E_BUFFER_TOO_SMALL            = 0x80090321,
    SEC_I_INCOMPLETE_CREDENTIALS      = 0x00090320,
    SEC_I_RENEGOTIATE                 = 0x00090321,
    SEC_E_WRONG_PRINCIPAL             = 0x80090322,
    SEC_I_NO_LSA_CONTEXT              = 0x00090323,
    SEC_E_TIME_SKEW                   = 0x80090324,
    SEC_E_UNTRUSTED_ROOT              = 0x80090325,
    SEC_E_ILLEGAL_MESSAGE             = 0x80090326,
    SEC_E_CERT_UNKNOWN                = 0x80090327,
    SEC_E_CERT_EXPIRED                = 0x80090328,
    SEC_E_ENCRYPT_FAILURE             = 0x80090329,
    SEC_E_DECRYPT_FAILURE             = 0x80090330,
    SEC_E_ALGORITHM_MISMATCH          = 0x80090331,
    SEC_E_SECURITY_QOS_FAILED         = 0x80090332,
  }
}
