// 
// Author:
//       smdn <smdn@mail.invisiblefulmoon.net>
// 
// Copyright (c) 2008-2009 smdn
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Runtime.InteropServices;

namespace Smdn.Interop.Sspi {
  [CLSCompliant(false)]
  public static class secur32 {
    public const uint SECURITY_NETWORK_DREP = 0x00000000;
    public const uint SECURITY_NATIVE_DREP = 0x00000010;

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS QuerySecurityPackageInfo(string pszPackageName, out IntPtr ppPackageInfo);

    [DllImport("secur32.dll")]
    public static extern SECURITY_STATUS FreeContextBuffer(IntPtr pvContextBuffer);

    [DllImport("secur32.dll")]
    public static extern SECURITY_STATUS DeleteSecurityContext(ref CtxtHandle phContext);

    [DllImport("secur32.dll")]
    public static extern SECURITY_STATUS FreeCredentialsHandle(ref CredHandle phCredential);

    [DllImport("secur32.dll")]
    public static extern SECURITY_STATUS CompleteAuthToken(ref CtxtHandle phContext, ref SecBufferDesc pToken);

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS AcquireCredentialsHandle(
      string pszPrincipal,
      string pszPackage,
      SECPKG_CRED fCredentialUse,
      IntPtr pvLogonID,
      ref SEC_WINNT_AUTH_IDENTITY pAuthData,
      int pGetKeyFn,
      IntPtr pvGetKeyArgument,
      out CredHandle phCredential,
      out TimeStamp ptsExpiry
    );

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS AcquireCredentialsHandle(
      string pszPrincipal,
      string pszPackage,
      SECPKG_CRED fCredentialUse,
      IntPtr pvLogonID,
      IntPtr pAuthData,
      int pGetKeyFn,
      IntPtr pvGetKeyArgument,
      out CredHandle phCredential,
      out TimeStamp ptsExpiry
    );

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS InitializeSecurityContext(
      ref CredHandle phCredential,
      IntPtr phContext,
      string pszTargetName,
      ISC_REQ fContextReq,
      uint Reserved1,
      uint TargetDataRep,
      IntPtr pInput,
      uint Reserved2,
      out CtxtHandle phNewContext,
      out SecBufferDesc pOutput,
      out uint pfContextAttr,
      out TimeStamp ptsExpiry
    );

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS InitializeSecurityContext(
      ref CredHandle phCredential,
      ref CtxtHandle phContext,
      string pszTargetName,
      ISC_REQ fContextReq,
      uint Reserved1,
      uint TargetDataRep,
      ref SecBufferDesc pInput,
      uint Reserved2,
      out CtxtHandle phNewContext,
      out SecBufferDesc pOutput,
      out uint pfContextAttr,
      out TimeStamp ptsExpiry
    );

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS AcceptSecurityContext(
      ref CredHandle phCredential,
      ref CtxtHandle phContext,
      ref SecBufferDesc pInput,
      ISC_REQ fContextReq,
      uint TargetDataRep,
      out CtxtHandle phNewContext,
      out SecBufferDesc pOutput,
      out uint pfContextAttr,
      out TimeStamp ptsTimeStamp
    );

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS AcceptSecurityContext(
      ref CredHandle phCredential,
      IntPtr phContext,
      ref SecBufferDesc pInput,
      ISC_REQ fContextReq,
      uint TargetDataRep,
      out CtxtHandle phNewContext,
      out SecBufferDesc pOutput,
      out uint pfContextAttr,
      out TimeStamp ptsTimeStamp
    );

    [DllImport("secur32.dll", CharSet = CharSet.Auto)]
    public static extern SECURITY_STATUS AcquireCredentialsHandle(
      string pszPrincipal,
      string pszPackage,
      SECPKG_CRED fCredentialUse,
      [In] ref long pvLogonID,
      SEC_WINNT_AUTH_IDENTITY pAuthData,
      int pGetKeyFn,
      IntPtr pvGetKeyArgument,
      ref CredHandle phCredential,
      ref TimeStamp ptsExpiry
    );
  }
}
